function P = bic(A)
% P = diord(A)
% Determines the permutation matrix for Best Instantaneous Convergence
%
% Copyright (C) 2014 Aravindh Krishnamoorthy
% aravindh.krishnamoorthy@ericsson.com, aravindh.k@ieee.org
% Released under the BSD license.
% Symmetric QR Algorithm with Permutations, arXiv:1402.5086.
%
N = size(A,1) ;
PP = perms(1:N) ;
L = length(PP) ;

C = zeros(1,L) ;
E = sort(eig(A)) ;
for i=1:L
    P = zeros(N,N) ;
    P((0:N-1)'*N+PP(i,:)') = 1 ;
    P = P' ;
    
    [Q,R] = qr(P*A*P') ;
    D = sort(real(diag(R*Q))) ;
    C(i) = norm(E-D) ;
end

[~,k] = find(C == min(C), 1) ;
P = zeros(N,N) ;
P((0:N-1)'*N+PP(k,:)') = 1 ;
P = P' ;
