function P = diord(A) 
% P = diord(A)
% Determines the permutation matrix for diagonal ordering.
%
% Copyright (C) 2014 Aravindh Krishnamoorthy
% aravindh.krishnamoorthy@ericsson.com, aravindh.k@ieee.org
% Released under the BSD license.
% Symmetric QR Algorithm with Permutations, arXiv:1402.5086.
%
N = size(A,1) ;
D = abs(real(diag(A))) ;

[~,I] = sort(D, 'descend') ;
P = zeros(N,N) ;
P((0:N-1)'*N+I) = 1 ;
P = P' ;
