function A = onestep_bic(A)
% A = onestep_bic(A)
% One iteration of QR algorithm with BIC permutation
%
% Copyright (C) 2014 Aravindh Krishnamoorthy
% aravindh.krishnamoorthy@ericsson.com, aravindh.k@ieee.org
% Released under the BSD license.
% Symmetric QR Algorithm with Permutations, arXiv:1402.5086.

P = bic(A) ;
[Q,R] = qr(P*A*P') ;
A = R*Q ;
A = (A+A')/2 ;
