function [A,Q] = onestep_diord (A)
% A = onestep_diord(A)
% One iteration of QR algorithm with diagonal ordering
%
% Copyright (C) 2014 Aravindh Krishnamoorthy
% aravindh.krishnamoorthy@ericsson.com, aravindh.k@ieee.org
% Released under the BSD license.
% Symmetric QR Algorithm with Permutations, arXiv:1402.5086.

P = diord(A) ;
[Q,R] = qr(P*A*P') ;
A = R*Q ;
A = (A+A')/2 ;
Q = P'*Q ;
