function A = onestep_qrs(A)
% A = onestep_qrs(A)
% One step of QR algorithm with shifts
% 
% Copyright (C) 2014 Aravindh Krishnamoorthy
% aravindh.krishnamoorthy@ericsson.com, aravindh.k@ieee.org
% Released under the BSD license.
% Symmetric QR Algorithm with Permutations, arXiv:1402.5086.

N = size(A,1) ;
s = A(N,N) ;
[Q,R] = qr(A-s*eye(N)) ;
A = R*Q+s*eye(N) ;
A = (A+A')/2 ;
